#if !defined(AFX_SETUPCOLUMNSPAGE_H__6696782D_4229_450A_B580_C37E352EA0B4__INCLUDED_)
#define AFX_SETUPCOLUMNSPAGE_H__6696782D_4229_450A_B580_C37E352EA0B4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupcolumnsPage.h : header file
//

#include "TemplateMaster.h"
#include "resource.h"
#include <AplGuiEx.h>
/////////////////////////////////////////////////////////////////////////////
// CSetupcolumnsPage dialog

class CSetupcolumnsPage : public CaplTranslateDialog
{
// Construction
public:
	bool FillData();
	bool TestUpdate();
	bool UpdateList();
	CTemplateMaster *m_pTemplate;
	CSetupcolumnsPage(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSetupcolumnsPage)
	enum { IDD = IDD_SETUP_COLUMNS_PAGE };
	CaplButton	m_up_btn;
	CaplButton	m_down_btn;
	CComboBox	m_PageSize_ComboCtrl;
	CaplListCtrl	m_Columns_ListCtrl;
	int		m_iOrient;
	double	m_dHeight;
	double	m_dWidth;
	double	m_dTableLineWidth;
	double	m_dTitleLineWidth;
	double	m_dLeft;
	double	m_dBottom;
	double	m_dRight;
	double	m_dTop;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupcolumnsPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSetupcolumnsPage)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangePageSizeCombo();
	afx_msg void OnPagePortal();
	afx_msg void OnPageLandscape();
	afx_msg void OnUp();
	afx_msg void OnDown();
	afx_msg void OnColumnlistEndedit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCalcColumnsWidth();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPCOLUMNSPAGE_H__6696782D_4229_450A_B580_C37E352EA0B4__INCLUDED_)
