#include "stdafx.h"
#include "mainfunctions.h"
#include "apl_api.h"
#include "resVedomDlg.h"

//************************************************************************
__declspec(dllexport) bool GetFunctionsList(CArray<CaplItemInfo*, CaplItemInfo*> *strArray)
{
	for(int i= 0; i<functionArraySize; i++)
	{
		strArray->Add(&functionArray[i]);
	}
	return true;
}

/*     - */
__declspec (dllexport) bool add_ShowAllBPResources(CaplAPI* api, 
								 aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || ! api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		api->m_bp_mgr.LoadBPInfo(inExtent);//   -

		for(int i= 0; i<inExtent.GetSize(); i++)
		{
			if(!inExtent[i]) continue;if(!inExtent[i]->GetId() || !inExtent[i]->GetType()) continue;

			if(api->m_data.IsKindOf(inExtent[i], api->m_bp_mgr.e_bp))
			{
				//   
				SetResources();

				CResVedomDlg dlg;
				dlg.m_api= api;
				dlg.m_bp=inExtent[i];
				dlg.DoModal();
		
				//    
				ResetResources();

			}
		}
	}
	return true;
}


/*        */
__declspec (dllexport) bool add_ShowAllPdfResources(CaplAPI* api, 
								 aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || ! api->m_data.IsConnected()) return false;
	if(!bUpdateUI)
	{
		if(inExtent.GetSize()==0) return false;
		CaplInstance *pdf = inExtent[0];

		if(!api->m_data.IsKindOf(pdf, api->m_prd_mgr.e_apl_pdf))
		{
			AfxMessageBox("       !");
			return false;
		}
	
		api->m_prd_mgr.LoadPrdInfo(pdf);//     

// 		for(int i= 0; i<inExtent.GetSize(); i++)
//		{
			//CaplInstance *pdf = inExtent[i];
			//if(pdf==0) continue;
			if(pdf->GetId()==0 || pdf->GetType()==0) return false;//continue;

// 			if(api->m_data.IsKindOf(pdf, api->m_prd_mgr.e_apl_pdf))
//			{
				//   
				SetResources();

				CResVedomDlg dlg;
				dlg.m_api= api;
				dlg.m_pdf=pdf;
				dlg.DoModal();
		
				//    
				ResetResources();

// 			}
// 			else if(api->m_data.IsKindOf(pdf, api->m_prd_mgr.e_prd))
// 			{
// 				AfxMessageBox("       !");
// 			}
		//}
	}
	return true;
}
//************************************************************************
void SetResources()
{
	if(afxCurrentResourceHandle!=0) 
		_hProcessInstance = AfxGetResourceHandle();
	AfxSetResourceHandle(_hDllInstance);	
}

void ResetResources()
{
	if(_hProcessInstance!=0)
	{
		AfxSetResourceHandle(_hProcessInstance);	
		_hProcessInstance= 0;
	}
}
//************************************************************************
