// resVedomDlg.h : header file
//

#if !defined(AFX_RESVEDOMDLG_H__29DA47AC_2850_42B1_BC8D_A6B335328691__INCLUDED_)
#define AFX_RESVEDOMDLG_H__29DA47AC_2850_42B1_BC8D_A6B335328691__INCLUDED_

#include "resource.h"
#include "apl_api.h"
#include <apl_gui.h>
//#include "ResizableDialog.h"
#include "InstPropertyCtrl.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class finalVedomost //       
{
public:
	CaplInstance* resource;//-
	CaplInstance* obj;//,     
	CaplInstance* unit;// 
	CaplInstance* resourceType;// 
	CaplInstance* bp;//- 
	CaplInstance* pdf;//,     
	CString resTypeName;// 
	CString resId;//id ,   
	CString resName;// ,   
	CString resVersion;// ,   
	double resMeasurement;// 
	double pdfMeasurement;// 
	CString resUnitType;//  

	aplExtent *pExtUsedPdfs; //    (  )

	finalVedomost()
	{
		resource=0;
		obj=0;
		unit=0;
		bp=0;
		pdf=0;
		resourceType=0;
		resTypeName="";
		resId="";
		resName="";
		resVersion="";
		pdfMeasurement=0;
		resMeasurement=0;
		resUnitType="";
		pExtUsedPdfs=0;
	}

	~finalVedomost()
	{
		if(0!=pExtUsedPdfs) delete pExtUsedPdfs;
	}

};
/////////////////////////////////////////////////////////////////////////////
// CResVedomDlg dialog
class CResVedomDlg : public CaplResizableDialog
{
// Construction
public:
	CaplAPI *m_api;//  
	CaplInstance *m_bp;//-,    (     -)
	CaplInstance *m_pdf;// ,      (      )
	aplExtent m_extBPs;//  -  (  )
	aplExtent m_extBPResources;//  
	CaplInstance *m_context;//    
	CString m_sn;//      
	COleDateTime m_time;//    


	CArray<finalVedomost,finalVedomost> finTable;//  

	bool GetBPResourceTypes(); //  listbox    
//	void FindAssociatedBP(aplExtent &ext,aplExtent &ext_out);//   -
	void GetAllBPResources(aplExtent &ext,bool from_base=true);//   -   ()
	bool FilterResourcesByType(CaplInstance *resource);//     
	void FillFinalStruct(CaplInstance *pdf=0,double pdf_amount=0);//   
//	bool GetResourceAttrs(finalVedomost *tempVed,CaplInstance *actionResource);//  
	bool SetOut();//  

	CResVedomDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CResVedomDlg)
	enum { IDD = IDD_RESVEDOM_DIALOG };
	CEdit	m_priority_ctrl;
	CaplButton	m_BtnCancel;
	CaplButton	m_BtnSelColumn;
	CaplButton	m_BtnSelChar;
	CaplButton	m_BtnSave;
	CaplButton	m_BtnGo;
	CEdit	m_time_ctrl;
	CEdit	m_sn_ctrl;
	CButton	m_filter_ctrl;
	CEdit	m_context_ctrl;
	CListBox	m_chosenResTypes;
	CListBox	m_resTypes;
	CEdit	m_actionId;
	CString	m_id;
	int		m_algorithm_type;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CResVedomDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//int m_CountALlString;
	CaplTAggr<SItemColumnData*,SItemColumnData*,APLAGGR_LIST_OR_AUTOKILLREF> m_Items;

	HICON m_hIcon;
	CInstPropertyCtrl m_reportCtrl;

	// Generated message map functions
	//{{AFX_MSG(CResVedomDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnAddResType();
	afx_msg void OnRemoveResType();
	afx_msg void OnGo();
	afx_msg void OnSave();
	virtual void OnCancel();
	afx_msg void OnAddAllResType();
	afx_msg void OnRemoveAllResType();
	afx_msg void OnFilter();
	afx_msg void OnBtnSelectColumn();
	afx_msg void OnSelectCharacterysticSet();
	afx_msg void OnDblclkResTypes();
	afx_msg void OnDblclkChosenTypes();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RESVEDOMDLG_H__29DA47AC_2850_42B1_BC8D_A6B335328691__INCLUDED_)
